<?php

namespace Controller;

use Exception;
use PDOException;
use Config\DataManagement;

/**
 * Permet de gérer l'appel des controllers en fonction de l'action et du rôle de l'utilisateur
 */
class FrontController
{
    /**
     * Définit le comportement de la classe à sa création, on appelle le bon controller en fonction de l'action
     * et du rôle de la personne qui souhaite réaliser cette action (utilisateur, administrateur...).
     */
    public function __construct()
    {
        global $rep, $views;
        $dVueError = array();
        $controllerPath = "\\Controller\\Controller";
        $mapRoleAccess = array(
            "Candidate" => array("Candidate"),
            "Admin" => array("Candidate", "Admin"));
        if (!isset($_SESSION["role"]))
            $currentRole = "Candidate";
        else $currentRole = Clean::simpleString($_SESSION["role"]);
        try {
            $action = isset($_REQUEST['action']) ? Clean::simpleString($_REQUEST['action']) : (new ControllerCandidate())->goToForm();
            foreach ($mapRoleAccess[$currentRole] as $role) {
                if (method_exists($controllerPath . $role, $action)) {
                    (new $controllerPath . $role)->$action(); // Si oui, on appelle cette fonction
                }
            }
        } catch (PDOException|Exception $e) {
            $dVueError[] = "Erreur innatendue !"; // Ecriture du message d'erreur
            echo "ERREUUUUUR";
        }
        exit(0);
    }
}